<?php

declare(strict_types=1);

namespace App\Repository;

final class TblSupervisorRepository
{
    private \PDO $database;

    public function __construct(\PDO $database)
    {
        $this->database = $database;
    }

    public function getDb(): \PDO
    {
        return $this->database;
    }

    public function checkAndGet(int $TblSupervisorId): object
    {
        $query = 'SELECT * FROM `TblSupervisor` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblSupervisorId);
        $statement->execute();
        $TblSupervisor = $statement->fetchObject();
        if (! $TblSupervisor) {
            throw new \Exception('TblSupervisor not found.', 404);
        }

        return $TblSupervisor;
    }

    public function getAll(): array
    {
        $query = 'SELECT * FROM `TblSupervisor` ORDER BY `id`';
        $statement = $this->getDb()->prepare($query);
        $statement->execute();

        return (array) $statement->fetchAll();
    }

    public function create(object $TblSupervisor): object
    {
        $query = 'INSERT INTO `TblSupervisor` (`NombreCompleto`, `IdPais`, `Codigo`, `field1`, `field2`, `field3`, `field4`, `field5`) VALUES (:NombreCompleto, :IdPais, :Codigo, :field1, :field2, :field3, :field4, :field5)';
        $statement = $this->getDb()->prepare($query);
//         $statement->bindParam('id', $TblSupervisor->id);
//         $statement->bindParam('fecha', $TblSupervisor->fecha);
        $statement->bindParam('NombreCompleto', $TblSupervisor->NombreCompleto);
        $statement->bindParam('IdPais', $TblSupervisor->IdPais);
        $statement->bindParam('Codigo', $TblSupervisor->Codigo);
        $statement->bindParam('field1', $TblSupervisor->field1);
        $statement->bindParam('field2', $TblSupervisor->field2);
        $statement->bindParam('field3', $TblSupervisor->field3);
        $statement->bindParam('field4', $TblSupervisor->field4);
        $statement->bindParam('field5', $TblSupervisor->field5);

        $statement->execute();

        return $this->checkAndGet((int) $this->getDb()->lastInsertId());
    }

    public function update(object $TblSupervisor, object $data): object
    {
        if (isset($data->fecha)) {
            $TblSupervisor->fecha = $data->fecha;
        }
        if (isset($data->NombreCompleto)) {
            $TblSupervisor->NombreCompleto = $data->NombreCompleto;
        }
        if (isset($data->IdPais)) {
            $TblSupervisor->IdPais = $data->IdPais;
        }
        if (isset($data->Codigo)) {
            $TblSupervisor->Codigo = $data->Codigo;
        }
        if (isset($data->field1)) {
            $TblSupervisor->field1 = $data->field1;
        }
        if (isset($data->field2)) {
            $TblSupervisor->field2 = $data->field2;
        }
        if (isset($data->field3)) {
            $TblSupervisor->field3 = $data->field3;
        }
        if (isset($data->field4)) {
            $TblSupervisor->field4 = $data->field4;
        }
        if (isset($data->field5)) {
            $TblSupervisor->field5 = $data->field5;
        }

        $query = 'UPDATE `TblSupervisor` SET `fecha` = :fecha, `NombreCompleto` = :NombreCompleto, `IdPais` = :IdPais, `Codigo` = :Codigo, `field1` = :field1, `field2` = :field2, `field3` = :field3, `field4` = :field4, `field5` = :field5 WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblSupervisor->id);
        $statement->bindParam('fecha', $TblSupervisor->fecha);
        $statement->bindParam('NombreCompleto', $TblSupervisor->NombreCompleto);
        $statement->bindParam('IdPais', $TblSupervisor->IdPais);
        $statement->bindParam('Codigo', $TblSupervisor->Codigo);
        $statement->bindParam('field1', $TblSupervisor->field1);
        $statement->bindParam('field2', $TblSupervisor->field2);
        $statement->bindParam('field3', $TblSupervisor->field3);
        $statement->bindParam('field4', $TblSupervisor->field4);
        $statement->bindParam('field5', $TblSupervisor->field5);

        $statement->execute();

        return $this->checkAndGet((int) $TblSupervisor->id);
    }

    public function delete(int $TblSupervisorId): void
    {
        $query = 'DELETE FROM `TblSupervisor` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblSupervisorId);
        $statement->execute();
    }
}
